package no.soliditet.wsclients.ws3.jaxrpc.client;

import no.soliditet.wsclients.ws3.jaxrpc.generated.*;

import javax.xml.rpc.ServiceException;
import java.net.MalformedURLException;
import java.rmi.RemoteException;

/**
 * @noinspection JavaDoc
 */
public class DecisionMakerWebServices3Impl extends DecisionMakerWebServices3ImplSuper implements no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3 {

   private static final String END_POINT_URL = "/webservices/services/DecisionMakerWebServices3?wsdl";


   public DecisionMakerWebServices3Impl() throws MalformedURLException, ServiceException {
      this(null);
   }

   public DecisionMakerWebServices3Impl(String hostName) throws MalformedURLException, ServiceException {
      super(hostName);
   }

   protected org.apache.axis.client.Stub getStubInstance() throws ServiceException {
      no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3ServiceLocator serviceLocator =
              new no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3ServiceLocator();
      return (no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)serviceLocator.getDecisionMakerWebServices3(getUrl());
   }

   protected String getEndPointUrl() {
      return END_POINT_URL;
   }

   /**
    * Get version of DecisionMaker and version of the DecisionMaker WebServices
    *
    * @return
    * @throws java.rmi.RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSVersion getVersion() throws RemoteException {
      return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).getVersion();
   }

   /**
    * Get status of server, its connection to its databases and its connection status to external dataproviders
    *
    * @param userName
    * @param password
    * @return
    * @throws java.rmi.RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSStatus[] getStatus(String userName, String password) throws RemoteException {
      return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).getStatus(userName, password);
   }

   /**
    * Perform specified scoring
    *
    * @param request
    * @return
    * @throws RemoteException
    */
   public DmWSResponse scoreX(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSRequest request) throws RemoteException {
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).scoreX(request);
      }
      catch (Exception e) {
         return new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse();
      }
   }

   /**
    * Get information on a previously performed scoring
    *
    * @param userName
    * @param passWord
    * @param requestId
    * @param scoreId   The scoreid to request for
    * @param extended  requesting for details of the scorecard if such. Needs special permissions
    * @return
    * @throws RemoteException
    */
   public DmWSResponse getScoreInformationById(String userName, String passWord, String requestId, String scoreId, boolean extended) throws RemoteException {
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).getScoreInformationById(userName, passWord, requestId,
                                                                                                                                         scoreId, extended);
      }
      catch (Exception e) {
         return new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse();
      }
   }

   /**
    * Update the score decision for a specified scoring. Needs special permission. Seldom used/needed
    *
    * @param userName
    * @param passWord
    * @param requestId
    * @param scoreId
    * @param decision
    * @param decisionCause
    * @return
    * @throws RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse updateScoreDecisionById(String userName, String passWord, String requestId, String scoreId,
                                                                                          String decision, String decisionCause) throws RemoteException {
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).updateScoreDecisionById(userName, passWord, requestId,
                                                                                                                                         scoreId, decision, decisionCause);
      }
      catch (Exception e) {
         return new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse();
      }
   }

   /**
    * get information, calls an information handler
    *
    * @param request
    * @return
    * @throws RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse getInformationX(no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSRequest request) throws RemoteException {
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).getInformationX(request);
      }
      catch (Exception e) {
         return new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse();
      }
   }

   /**
    * Get information, calls an information handler
    *
    * @param userName
    * @param passWord
    * @param handlerName
    * @return
    * @throws RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse getInformation(String userName, String passWord, String userRef,
                                                                                 String requestId, no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant applicant,
                                                                                 String handlerName) throws RemoteException {
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).getInformation(userName, passWord, userRef,
                                                                                                                                requestId, applicant, handlerName);
      }
      catch (Exception e) {
         return new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSResponse();
      }
   }

   /**
    * Performs a scoring on specified applicant using the specified product. Takes only one single applicant as request. Assumes a single response is
    * returned (should always be).
    *
    * @param userName
    * @param passWord
    * @param applicant
    * @param productName
    * @return The no.soliditet.wsclients.ws3.generated.DmWSScoreResponse or no.soliditet.wsclients.ws3.generated.DmWSError object
    * @throws RemoteException
    */
   public no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse score(String userName, String passWord, String userRef, String requestId,
                                                                              no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant applicant,
                                                                              String productName) throws RemoteException {
      // we need an applicant object:
      if (applicant == null)
         applicant = new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant();

      if (applicant.getType() == null) {
         // it's a person (not a company) by default
         applicant.setType("P");
      }

      // run the request:
      try {
         return ((no.soliditet.wsclients.ws3.jaxrpc.generated.DecisionMakerWebServices3SoapBindingStub)getStub()).score(userName, passWord, userRef, requestId,
                                                                                                                       applicant, productName);
      }
      catch (Exception e) {
         return handleClientSideError(e);
      }
   }

   /**
    * @noinspection UNUSED_SYMBOL, UnusedDeclaration
    */
   public static void main2(String[] args) {
      // we need an applicant object:
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant applicant = new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant();
      // who to search for
      applicant.setSsn("1234567890");

      // run the request:
      DecisionMakerWebServices3Impl scorer;
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSSingleResponse response = null;
      try {
         scorer = new DecisionMakerWebServices3Impl("www.soliditetd.no");
         response = scorer.score("username", "password", "userRef", "request No 1", applicant, "Test Person");
      }
      catch (MalformedURLException | RemoteException | ServiceException e) {
         e.printStackTrace();
      }

      /* Now we	must add	code to handle the response: */

      // handling the result:
      if (response != null) {
         if (response instanceof DmWSError) {
            // So an error occurred:
            DmWSError error = (DmWSError)response;
            System.out.println("Error code: " + error.getErrorCode());
            System.out.println("Error message: " + error.getErrorMessage());
            System.out.println("What to do: " + error.getErrorMeasure());
         }
         else if (response instanceof DmWSScoreResponse) {
            // we got a score response:
            DmWSScoreResponse sr = (DmWSScoreResponse)response;
            System.out.println("Decision zone:" + sr.getZone());
            String decision = sr.getResult();
            switch (decision) {
               case "y":
                  decision = "Approved";
                  break;
               case "n":
                  decision = "Not approved";
                  break;
               case "c":
                  decision = "Check";
                  break;
            }

            System.out.println("Decision: " + decision);

            // A policy rule might have occurred, gotta check:
            ArrayOfDmWSScoring arrayOfscorings = sr.getScorings();
            // usually only one scoring object
            if ((arrayOfscorings != null) && (arrayOfscorings.getItem() != null) && (arrayOfscorings.getItem().length > 0)) {
               DmWSScoring[] scorings = arrayOfscorings.getItem();
               ArrayOfDmWSPolicyElement arrayOfpes = scorings[0].getPolicyElements();

               if ((arrayOfpes != null) && (arrayOfpes.getItem() != null) && (arrayOfpes.getItem().length > 0)) {
                  DmWSPolicyElement[] pes = arrayOfpes.getItem();
                  for (DmWSPolicyElement pe : pes) {
                     if (pe != null) {
                        System.out.println("Policy name: " + pe.getName());
                        System.out.println("Policy message: " + DecisionMakerWebServices3Impl.getActionMessage(pe));
                     }
                  }
               }
               // It may also be interesting to get the TotalScore elements from the scoring:
               ArrayOfDmWSTotalScoreElement arrayOftes = scorings[0].getTotalScoreElements();

               if ((arrayOftes != null) && (arrayOftes.getItem() != null) && (arrayOftes.getItem().length > 0)) {
                  DmWSTotalScoreElement[] tes = arrayOftes.getItem();
                  // A totalscore element is usually only one ?
                  if (tes[0] != null) {
                     // ?? and with several sub-elements
                     ArrayOfDmWSElement arrayOfelements = tes[0].getElements();
                     if ((arrayOfelements != null) && (arrayOfelements.getItem() != null) && (arrayOfelements.getItem().length > 0)) {
                        DmWSElement[] elements = arrayOfelements.getItem();
                        for (DmWSElement element : elements) {
                           // Display name and value:
                           System.out.println(element.getName() + ": " + element.getVal());
                        }
                     }
                  }
               }
            }
         }
         else {
            // Unknown result, should never happen, but should be handled anyway
            System.out.println("Unknown result: " + response.toString());
         }
      }
   }

   public void doNotUseThis(DmWSAddress in0, DmWSAppInfo in1, DmWSApplicant in2, DmWSAttribute in3, DmWSDataElement in4, DmWSEiendomsInfo in5, DmWSElement in6,
                            DmWSError in7, DmWSInformationRequest in8, DmWSInformationResponse in9, DmWSAdminRequest in10, DmWSAnyResponse in11,
                            DmWSMemberValue in12, DmWSPolicyElement in13, DmWSRequest in14, DmWSSingleResponse in15, DmWSScoreElement in16,
                            DmWSScoreRequest in17, DmWSScoreResponse in18, DmWSScoring in19, DmWSSingleRequest in20, DmWSSingleResponse in21,
                            DmWSStatus in22, DmWSTotalScoreElement in23, DmWSVersion in24, DmWSZone in25, DmWSResponse in26) throws RemoteException {
      //do not implement
   }

   public static void main(String[] args) {
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSRequest mainRequest = new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSRequest();
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreRequest[] requests =
              new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreRequest[]{new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSScoreRequest()};
      // user identification/login name
      mainRequest.setUser("username");
      mainRequest.setPassWord("password");
      ArrayOfDmWSSingleRequest arrayOfSr = new ArrayOfDmWSSingleRequest();
      arrayOfSr.setItem(requests);
      // set list of requests
      mainRequest.setRequests(arrayOfSr);
      // score product
      requests[0].setProductName("Standard Person");
      // will be returned with response (optional)
      requests[0].setRequestId("test score no. 1");

      // we need an applicant object:
      no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant[] applicants =
              new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant[]{new no.soliditet.wsclients.ws3.jaxrpc.generated.DmWSApplicant()};
      // who to search for
      applicants[0].setSsn("1234567890");
      applicants[0].setNationality("no");
      applicants[0].setType("P");
      ArrayOfDmWSApplicant arrayOfApps = new ArrayOfDmWSApplicant();
      arrayOfApps.setItem(applicants);
      // give the applicants list to the request
      requests[0].setApplicants(arrayOfApps);

      //run the request:
      try {
         //noinspection UnusedDeclaration
         DmWSResponse response = new DecisionMakerWebServices3Impl(getDefaultHost()).scoreX(mainRequest);
         /*
             * Find the result in the response class
            */
      }
      catch (RemoteException | MalformedURLException | ServiceException e) {
         e.printStackTrace();
      }
   }
}
